(* $Id: misc.mli 11 2007-02-28 09:38:48Z pierre $ *)
(** 
 Miscellaneous functions.

 @version October 26, 2004
 @author Pierre Lemaire
*)

(* ============================================================================
author: Pierre Lemaire
2004-10-26             : creation
============================================================================ *)

open Lexing;;
open Arg;;

(** value use for EOL *) 
val eol: string ref

(* ======================================================================= *)
(** {6 standard options} *)

(** the common options; uses (name, version, description, author, copyright)*)
val common_options: (string * string * string * string * string)
  -> (key * spec * doc) list

(** options for managing EOL *)
val eol_options: (key * spec * doc) list

(* ======================================================================= *)
(** {6 misc.} *)

(** the identity function. *)
val id: 'a -> 'a

(** [set_ref r v] sets the value [v] to the reference [r]. *)
val set_ref: 'a ref  -> 'a -> unit
