/* $Id: observation_gra.mly 1 2005-07-15 19:39:24Z lemaire $ */
%{
let k = ref (-1)
let v = ref []
let n = ref ""

%}
%token <int> INT
%token <float> FLOAT
%token <string> STRING
%token EOL
%token SEP

%start read
%type <string*int*float list> read
%%
read:                      /* returns the values and clear them */
  observation       { let tmp = (!n, !k, !v)
		      in
			k := -1; v := []; n := "";
			tmp
		    } 
  ;

observation:
  name SEP kind SEP values {}
| kind SEP values   { }
;

name:
  STRING            { n := $1 }
;

kind:
  INT               { k := $1 }
;

values:
  num EOL           { v := $1::(!v) }
| num SEP values    { v := $1::(!v) }
| SEP values        { v := nan::(!v) }
| EOL               { v := nan::(!v) }
;

num:
  INT                       { float_of_int $1 }
| FLOAT                     { $1 }
