/* $Id: pattern_gra.mly 1 2005-07-15 19:39:24Z lemaire $ */
%{
let kind = ref (-1)
let hom  = ref nan
let pre  = ref nan
let hr   = ref nan
let mons = ref []
%}
%token <int> INT
%token <float> FLOAT
%token EOL
%token SEP
%token INF
%token SUP
%token AND
%token OPEN
%token CLOSE
%token COMA
%token END
%token <int> VAR

%start read
%type <(int*float*float*float)*(int*float*float) list> read
%%
read:                      /* returns the values and clear them */
  pattern                  { let tmp = (!kind, !hom, !pre, !hr), !mons
                             in kind := (-1); hom := nan; pre := nan;
			        hr := nan; mons := [];
                                tmp;
                           }
| nomore                   { raise End_of_file; }
;

nomore:
  END                      {}
;

pattern:
  characteristics monomes  {}
;

characteristics:
  OPEN INT COMA num COMA num CLOSE { kind := $2; hom := $4; pre := $6; }
| OPEN INT COMA num COMA num COMA num CLOSE { kind := $2; hom := $4;
					      pre := $6; hr := $8; }
;

monomes:
  monome EOL                {}
| monome AND monomes        {}
;

monome:
  num INF VAR               { mons := ($3,$1,infinity)::!mons; }
| num SUP VAR               { mons := ($3,neg_infinity,$1)::!mons; }
| VAR SUP num               { mons := ($1,$3,infinity)::!mons; }
| VAR INF num               { mons := ($1,neg_infinity,$3)::!mons; }
| num INF VAR INF num       { mons := ($3,$1,$5)::!mons; }
| num SUP VAR SUP num       { mons := ($3,$5,$1)::!mons; }
;

num:
  INT                       { float_of_int $1 }
| FLOAT                     { $1 } 

