(* $Id: pattern_lex.mll 8 2005-12-13 11:23:16Z lemaire $ *)
{
(* open Messages;; *)
open Pattern_gra;;
}

rule token = parse
  | [' ']
      { (* trace TRACE_DEBUG " "; *)
	token lexbuf } (* skip spaces *)
  | ['\n''\r']+(*  as x *)
      { (* trace TRACE_DEBUG x; *)
	EOL }
  | eof
      { EOL }
  | ('-')?['0'-'9']+'.'['0'-'9']* as x
      { (* trace TRACE_DEBUG x; *)
	FLOAT (float_of_string x) }
  | ('-')?['0'-'9']+ as x
      { (* trace TRACE_DEBUG x; *)
	INT (int_of_string x) }
  | "nan"
      { (* trace TRACE_DEBUG "nan"; *)
	FLOAT nan }
  | "inf"
      { (* trace TRACE_DEBUG "inf"; *)
	FLOAT infinity }
  | '<'
      { (* trace TRACE_DEBUG "<"; *)
	INF }
  | '>'
      { (* trace TRACE_DEBUG ">"; *)
	SUP }
  | '&'
      { (* trace TRACE_DEBUG "&"; *)
	AND }
  | '('
      { (* trace TRACE_DEBUG "("; *)
	OPEN }
  | ')'
      { (* trace TRACE_DEBUG ")"; *)
	CLOSE }
  | ','
      { (* trace TRACE_DEBUG ","; *)
	COMA }
  | '#'+['\n''\r']* (* as x  *)
      { (* trace TRACE_DEBUG x; *)
	END }
  | ('x'|'X')(['0'-'9']+ as s) (* as x *)
      { (* trace TRACE_DEBUG x; *)
	VAR (int_of_string s) }
